/*
 * Copyright (c) 2008-2012 GIANTS Software GmbH, Confidential, All Rights Reserved.
 * Copyright (c) 2003-2012 Christian Ammann and Stefan Geiger, Confidential, All Rights Reserved.
 */

precision mediump float;

// varying for fragmet shader

varying mediump vec2 v_TexCoord0;

uniform sampler2D s_TexUnit0;
uniform lowp vec4 u_Color;

void main()
{
    const float textureBlendDistance = 15.0; // this is the pixel distance mapped to 0.5 texture value
    const float blendDistance = 1.1;
    const float width = 0.5 * blendDistance / textureBlendDistance;

    // Parameters to smoothstep() should be medium precision since e.g. Tegra2 GPU cannot match overloaded function otherwise.
    // lowp float alpha = texture2D(s_TexUnit0, v_TexCoord0).x;
    mediump float alpha = texture2D(s_TexUnit0, v_TexCoord0).x;
    alpha = smoothstep(0.5-width, 0.5+width, alpha);

    gl_FragColor = vec4(1.0,1.0,1.0,alpha) * u_Color;
}
