/*
 * Copyright (c) 2008-2012 GIANTS Software GmbH, Confidential, All Rights Reserved.
 * Copyright (c) 2003-2012 Christian Ammann and Stefan Geiger, Confidential, All Rights Reserved.
 */

precision highp float;
precision mediump int;

uniform mat4 u_mwMatrix;
uniform mat4 u_mvpMatrix;
//#define u_MSToLSMatrix u_mvMatrix

uniform lowp vec3 u_dLightAmbient;
uniform lowp vec3 u_dLightDiffuse;
uniform	mediump vec4 u_sLightPositionWS;
uniform mediump vec3 u_dLightDirectionWS;
    
attribute vec3 Position;
attribute vec2 TexCoord0;

varying mediump vec2 v_TexCoord0;
//varying lowp vec3 v_Normal;
varying lowp vec3 v_Color;
varying mediump vec3 v_sLightDir;

#if defined(ANIMATE)
    uniform vec4 u_animCrop;
#endif

void main()
{
    v_TexCoord0 = TexCoord0;   
    #if defined(ANIMATE)
        vec3 direction = vec3(1,0,0)*0.1;
        float offset = sin(u_animCrop.x + Position.x * Position.z) * Position.y;
        vec4 pos = vec4(Position.xyz + direction * offset, 1.0);
    #else
        vec4 pos = vec4(Position, 1.0);    
    #endif
    
    gl_Position = u_mvpMatrix * pos;
    
    vec3 posWS = (u_mwMatrix * pos).xyz;
    //v_Normal = vec3(0.0, 1.0, 0.0);
    v_sLightDir = (u_sLightPositionWS.xyz - posWS) / 50.0;
    float ndotl = max(dot(vec3(0.0, 1.0, 0.0), u_dLightDirectionWS), 0.0);
    v_Color = (ndotl*u_dLightDiffuse) + u_dLightAmbient;
    
    // switch coords to landscape mode for iphone
#ifdef SWITCH_XY
    gl_Position.xy=vec2(gl_Position.y, -gl_Position.x);
#endif
}
